<template>
	<f7-page name="accountedit" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">Akun</f7-nav-title>
            <f7-nav-title-large>Detil Profil</f7-nav-title-large>
		</f7-navbar>

		<!-- Page content-->
        <f7-block>
            <div class="display-block text-align-center">
                <div class="img-uploader">
                    <img v-if="user.profile.media != null" :src="user.profile.media.url.small" width="96" class="img-circle">
				    <div v-else :data-initial-extra-large-circle="user.profile.initial"></div>
                </div>
            </div>
        </f7-block> 
        <f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="no-margin gradient-cyan">
            <h3 class="no-margin">Penting!</h3>
            <p>Data Anda selalu rahasia dan tidak akan kami beritahukan kepada pihak lain.</p>
        </f7-block>       
        <f7-block-title class="font-bold no-margin-left">Data Diri</f7-block-title>
        <f7-list no-hairlines class="no-margin">
            <f7-list-input
				ref="fullname"
				label="Nama Lengkap"
				placeholder="Nama lengkap anda"
				maxlength="255"
				clear-button
				:value="accountForm.fullname"
				@input="accountForm.fullname = $event.target.value">
			</f7-list-input>
            <f7-list-input
                ref="address"
                type="textarea"
                label="Alamat"
                placeholder="Ketik alamat lengkap"
                resizable					
                :value="accountForm.address"
                @input="accountForm.address = $event.target.value">
            </f7-list-input>
            <li class="item-content item-input">
                <div class="item-inner">
                    <div class="item-title item-label">Kode Pos</div>
                    <div class="item-input-wrap">
                    <input id="region" type="text" placeholder="Ketik kode pos">
                    </div>
                </div>
            </li>
        </f7-list>
         <f7-list no-hairlines inline-labels class="no-margin">
            <li class="item-content item-input">
                <div class="item-inner">
                    <div class="item-title item-label">Jenis Kelamin</div>
                    <div class="item-input-wrap">
                        <p class="no-margin text-align-right">
                            <f7-radio 
                                name="gender" 
                                value="m" 
                                :checked="accountForm.gender === 'm'"
                                @change="accountForm.gender = $event.target.value"></f7-radio> Laki-Laki
                            <f7-radio 
                                name="gender" 
                                value="f"
                                :checked="accountForm.gender === 'f'"
                                @change="accountForm.gender = $event.target.value"></f7-radio> Perempuan
                        </p>
                    </div>
                </div>
            </li>
            <f7-list-input
                class="align-right"
				ref="phone"
				label="No. Handphone"
				placeholder="08xxxxxxxxxxx"
				maxlength="25"
				:value="accountForm.phone"
				@input="accountForm.phone = $event.target.value">
			</f7-list-input>
            <f7-list-input
				class="align-right"
				label="Tanggal Lahir"
				type="datepicker"
				placeholder="Pilih Tanggal"
				formatValue="YYYY-MM-DD"
				readonly
				:value="[accountForm.birthday]"
				:calendar-params="{
					'closeOnSelect': true,
					monthNames: ['Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'November', 'Desember'],
					monthNamesShort: ['Jan', 'Feb', 'Mar', 'Apr', 'Mei', 'Jun', 'Jul', 'Agu', 'Sep', 'Okt', 'Nov', 'Des'],
					dayNames: ['Minggu', 'Senin', 'Selasa', 'Rabu', 'Kamis', 'Jumat', 'Sabtu'],
					dayNamesShort: ['Min', 'Sen', 'Sel', 'Rab', 'Kam', 'Jum', 'Sab'],
				}"
                @change="accountForm.birthday = $event.target.value"
			></f7-list-input>
         </f7-list>
         <f7-button @click="doSubmit" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>Simpan</f7-button>
    </f7-page>
</template>
<script>
import moment from 'moment';
import { mapGetters } from 'vuex';
import { dateFormat, capitalize, parseError } from '../js/utils';
export default {
    name: 'AccountEdit',
    data(){
        return{
            accountForm: {
                fullname: '',
                gender: '',
                birthday: new Date(),
                phone: '',
                address: '',
                region: null
            }
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('region', ['regions']),
    },
    methods: {
        dateFormat,
        capitalize,
        parseRegion(postal, path){
            path = path.split('/');
            path.reverse();
            return postal + ' - ' + capitalize(path[0].replace('-', ' '));
        },
        onPageBeforeIn(){
            const self = this;

            self.accountForm.fullname = self.user.profile.fullname;
            self.accountForm.gender = self.user.profile.gender != null ? self.user.profile.gender : '';
            self.accountForm.phone = self.user.profile.phone != null ? self.user.profile.phone : '';
            self.accountForm.birthday = self.user.profile.birthday != null ? new Date(self.user.profile.birthday) : new Date();
            self.accountForm.address = self.user.profile.address != null ? self.user.profile.address : '';
            self.accountForm.region = self.user.profile.profile_region_id != null ? self.user.profile.profile_region_id : null;
        },
        onPageBeforeOut(page){
            if(page.detail.name == 'accountedit'){
                self.accountForm = {
                    fullname: '',
                    gender: '',
                    birthday: new Date(),
                    phone: '',
                    address: '',
                    region: null
                };
            }
        },
        doSubmit(){
            const self = this;
			const app = self.$f7;

			if(self.accountForm.fullname.length == 0){
				app.dialog.alert('Silahkan isi nama lengkap', 'RingSatu');
				return false;
			}else if(/^([a-zA-Z0-9\s]{1,255})$/.test(self.accountForm.fullname) == false){
				app.dialog.alert('Nama lengkap hanya boleh diisi dengan dengan huruf, angka, dan spasi.', 'RingSatu');
				return false;
			}else if(/\(?(?:\+628|628|08)(?:\d{2,3})?\)?[ .-]?\d{2,4}[ .-]?\d{2,4}[ .-]?\d{2,4}/.test(self.accountForm.phone) == false){
				app.dialog.alert('Format No. Handphone tidak valid', 'RingSatu');
				return false;
			}else if(self.accountForm.gender.length == 0){
				app.dialog.alert('Silahkan pilih jenis kelamin', 'RingSatu');
				return false;			
			}else if(['m', 'f'].indexOf(self.accountForm.gender) === -1){
				app.dialog.alert('Silahkan pilih jenis kelamin', 'RingSatu');
				return false;
			}else if(self.accountForm.birthday.length === 0){
				app.dialog.alert('Silahkan pilih tanggal lahir', 'RingSatu');
				return false;
			}else if(self.accountForm.address.trim().length == 0){
				app.dialog.alert('Alamat wajib diisi.', 'RingSatu');
                return false;
            }else if(self.accountForm.address.trim().length > 255){
				app.dialog.alert('Alamat tidak boleh lebih 255 karakter.', 'RingSatu');
                return false;
            }else if(self.accountForm.region == null){
				app.dialog.alert('Kode pos wajib diisi.', 'RingSatu');
                return false;
            }

			app.preloader.show('green');

			let params = {};

			params.fullname = self.accountForm.fullname;
            params.birthday = self.accountForm.birthday;
            params.gender = self.accountForm.gender;
            params.phone = self.accountForm.phone;
            params.address = self.accountForm.address;
            params.region = self.accountForm.region;
			params.exclude = 'role.permissions,parents.childs,parents.role.permissions'

			self.$store.dispatch('auth/updateMe', params).then((response) => {
				app.preloader.hide();

                if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.refreshPage({
						ignoreCache: true
					});
				}
			});
        }
    },
    mounted(){
        const self = this;
        const app = self.$f7;
        const $$ = self.$$;
        const $el = $$(self.$el);

        if(self.user.profile.profile_region_id != null){
            $el.find('input#region').val(self.user.profile.profile_region[4]);
        }        

        app.autocomplete.create({
            inputEl: '#region',
            openIn: 'dropdown',
            preloader: true,
            valueProperty: 'id',
            textProperty: 'postal',
            limit: 25,
            minLength: 3,
            typeahead: true,
            closeOnSelect: true,
            dropdownPlaceholderText: 'Ketik kode pos',
            source: function (query, render) {
                var autocomplete = this;
                var results = [];
                if (query.length === 0) {
                    render(results);
                    return;
                }else if(query.length >= 3){
                    autocomplete.preloaderShow();

                    setTimeout(() => {
                        self.$store.dispatch('region/getRegions', {
                            q: query
                        }).then((response) => {
                            for(const x of self.regions){
                                if(x.postal.indexOf(query) > -1){
                                    results.push(x);
                                }
                            }
                            autocomplete.preloaderHide();
                            render(results);
                        });
                    }, 300);
                }                
            },
            renderItem: function(item, index){
                var that = this,
                    items = that.items;

                var obj = app.utils.extend(item, items[index]),
                    tmpl = '';

                if(obj.placeholder){
                    return '<li>'+
                            '<label class="item-radio item-content" data-value="Ketik kode pos">'+
                                '<div class="item-inner">'+
                                '<div class="item-title">Ketik kode pos</div>'+
                                '</div>'+
                            '</label>'+
                            '</li>';
                }else{
                    tmpl = '<li>'+
                            '<label class="item-radio item-content" data-value="'+obj.id+'">'+
                                '<div class="item-inner">'+
                                '<div class="item-title">'+self.parseRegion(obj.postal, obj.path)+'</div>'+
                                '</div>'+
                            '</label>'+
                            '</li>';

                    return tmpl;
                }
            },
            on: {
                change: function(value){
                    value = value[0];
                    self.accountForm.region = value.id;
                    $el.find('input#region').val(value.postal);
                }
            }
        });

        $$(document).on('click', '.img-uploader', function(e) {
            e.preventDefault();

            var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {
                                    
                                    app.preloader.show('green');

                                    var payload = {url: '/media/profile/'+self.user.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);
                                            self.$store.dispatch('auth/updateProfile', {
                                                user: response.data.user
                                            });

                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/profile/'+self.user.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);

                                        self.$store.dispatch('auth/updateProfile', {
                                            user: response.data.user
                                        });

                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
        });
    }
}
</script>
